<!--Alert messages here-->
<div
  class="alert alert-success alert-dismissible fade show"
  role="alert"
  style="max-width: 50%; margin-bottom: -35px"
  *ngIf="successModifyUser"
>
  Les modifications ont été opérées avec<strong> succès !</strong>
  <button
    type="button"
    class="btn-close"
    data-bs-dismiss="alert"
    aria-label="Close"
  ></button>
</div>

<div
  class="alert alert-danger alert-dismissible fade show"
  role="alert"
  style="max-width: 50%; margin-bottom: -35px"
  *ngIf="failModifyUser"
>
  <strong>Attention </strong> Ce type existe déjà !
  <button
    type="button"
    class="btn-close"
    data-bs-dismiss="alert"
    aria-label="Close"
  ></button>
</div>
<!--Table here-->
<div class="containerAddButton">
  <button
    *ngIf="this.user.isAdmin"
    type="button"
    class="btn addButton"
    data-toggle="modal"
    (click)="myModal.show()"
  >
    Ajouter un utilisateur
  </button>
</div>
<div class="card">
  <div class="card-body">
    <div class="loadingTableContainer" *ngIf="isLoading || dataNotFound">
      <div class="loadingTable">
        <div class="dataNotFound" *ngIf="isLoading">
          <div style="opacity: 0.7; color: black">Chargement ...</div>
          <img
            src="../../../assets/img/gif/cloud.gif"
            alt="this scope moves"
            width="70"
          />
        </div>
        <div class="dataNotFound" *ngIf="dataNotFound">
          <div style="color: black">Aucune donnée trouvée !</div>
          <img
            src="../../../assets/img/gif/zoom.gif"
            alt="this scope moves"
            width="50"
          />
        </div>
      </div>
    </div>
    <table class="table table-striped">
      <thead style="z-index: 88" class="tableHead">
        <tr class="table-sm cc">
          <th style="width: 10%; min-width: 60px">
            ID
            <input
              *ngIf="filterId"
              class="inputFilter"
              style="width: 50px"
              type="text"
              [(ngModel)]="filters[0]['id']"
              (keyup)="getUsers(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterId = !filterId"
            ></i>
          </th>
          <th style="min-width: 80px">
            Nom
            <input
              *ngIf="filterNom"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[5]['last_name']"
              (keyup)="getUsers(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterNom = !filterNom"
            ></i>
          </th>
          <th style="min-width: 80px">
            Prénom
            <input
              *ngIf="filterLastName"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[6]['first_name']"
              (keyup)="getUsers(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterLastName = !filterLastName"
            ></i>
          </th>
          <th style="min-width: 80px">
            Email
            <input
              *ngIf="filterEmail"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[3]['email']"
              (keyup)="getUsers(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterEmail = !filterEmail"
            ></i>
          </th>
          <th style="min-width: 80px">
            Role
            <div
              *ngIf="filterRole"
              class="col-form-label inputFilterActif"
              style="padding-right: 8px"
            >
              <div class="form-check">
                <input
                  type="radio"
                  name="radiosRole"
                  id="radiosRole1"
                  value=""
                  class="form-check-input"
                  [(ngModel)]="filters[4]['is_active']"
                  (change)="getUsers(1)"
                  checked=""
                />
                <label for="radiosRole1" class="form-check-label"> ALL </label>
              </div>
              <div class="form-check">
                <input
                  type="radio"
                  name="radiosRole"
                  id="radiosRole2"
                  value="true"
                  class="form-check-input"
                  [(ngModel)]="filters[4]['is_active']"
                  (change)="getUsers(1)"
                />
                <label for="radiosRole2" class="form-check-label">
                  Admin
                </label>
              </div>
              <div class="form-check">
                <input
                  type="radio"
                  name="radiosRole"
                  id="radiosRole3"
                  value="false"
                  class="form-check-input"
                  [(ngModel)]="filters[4]['is_active']"
                  (change)="getUsers(1)"
                />
                <label for="radiosRole3" class="form-check-label">
                  Simple utilisateur
                </label>
              </div>
            </div>
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterRole = !filterRole"
            ></i>
          </th>
          <th *ngIf="this.user.isAdmin" style="width: 15%; min-width: 80px">
            Actif
            <div *ngIf="filterActif" class="col-form-label inputFilterActif">
              <div class="form-check">
                <input
                  type="radio"
                  name="radios"
                  id="radio1"
                  value=""
                  class="form-check-input"
                  [(ngModel)]="filters[4]['is_active']"
                  (change)="getUsers(1)"
                  checked=""
                />
                <label for="radio1" class="form-check-label"> ALL </label>
              </div>
              <div class="form-check">
                <input
                  type="radio"
                  name="radios"
                  id="radio2"
                  value="true"
                  class="form-check-input"
                  [(ngModel)]="filters[4]['is_active']"
                  (change)="getUsers(1)"
                />
                <label for="radio2" class="form-check-label"> Active </label>
              </div>
              <div class="form-check">
                <input
                  type="radio"
                  name="radios"
                  id="radio3"
                  value="false"
                  class="form-check-input"
                  [(ngModel)]="filters[4]['is_active']"
                  (change)="getUsers(1)"
                />
                <label for="radio3" class="form-check-label"> Inactive </label>
              </div>
            </div>
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterActif = !filterActif"
            ></i>
          </th>
          <th *ngIf="this.user.isAdmin" style="width: 80px; padding: 15px 0px">
            Actions
          </th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let usr of users">
          <td>{{ usr.id }}</td>
          <td>{{ usr.last_name }}</td>
          <td>{{ usr.first_name }}</td>
          <td>{{ usr.email }}</td>
          <td>
            {{ usr.roles[0] === "ROLE_USER" ? "Simple utilisateur" : "Admin" }}
          </td>
          <td *ngIf="this.user.isAdmin">
            <label class="switch switch-label switch-pill switch-success">
              <input
                type="checkbox"
                [(ngModel)]="usr.is_active"
                (click)="changeStatut(usr.id, usr.is_active)"
                class="switch-input"
              />
              <span
                data-checked="✓"
                data-unchecked="✕"
                class="switch-slider"
              ></span>
            </label>
          </td>
          <td style="z-index: 2222" *ngIf="this.user.isAdmin">
            <div class="editIcon">
              <i
                class="icon-note icons font-2xl"
                (click)="showUpdateModal(usr); myUpdateModal.show()"
              ></i>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
  <div class="count">
    <div>Résultats {{ users.length }} (filtrés parmi {{ totalCount }})</div>
  </div>
</div>
<!--Pagination here-->
<div class="pages" *ngIf="totalCount > 10">
  <ul class="pagination">
    <li class="page-item" (click)="getUsers(pagination.first)">
      <a class="page-link"><i class="fa fa-angle-double-left fa-lg"></i></a>
    </li>

    <li class="page-item" (click)="getUsers(pagination.prev)">
      <a class="page-link" *ngIf="pagination.first < pagination.current"
        ><i class="fa fa-angle-left fa-lg"></i
      ></a>
    </li>
    <li class="page-item" (click)="getUsers(pagination.prev - 1)">
      <a class="page-link" *ngIf="pagination.first < pagination.prev">..</a>
    </li>
    <li class="page-item" (click)="getUsers(pagination.prev)">
      <a class="page-link" *ngIf="pagination.prev < pagination.current">{{
        pagination.prev
      }}</a>
    </li>
    <li class="page-item active" (click)="getUsers(pagination.current)">
      <a class="page-link">{{ pagination.current }}</a>
    </li>
    <li class="page-item" (click)="getUsers(pagination.next)">
      <a class="page-link" *ngIf="pagination.next > pagination.current">{{
        pagination.next
      }}</a>
    </li>
    <li class="page-item">
      <a
        class="page-link"
        (click)="getUsers(pagination.next + 1)"
        *ngIf="pagination.next < pagination.last"
        >..</a
      >
    </li>
    <li class="page-item" (click)="getUsers(pagination.next)">
      <a class="page-link" *ngIf="pagination.current != pagination.last"
        ><i class="fa fa-angle-right fa-lg"></i
      ></a>
    </li>
    <li class="page-item" (click)="getUsers(pagination.last)">
      <a class="page-link"><i class="fa fa-angle-double-right fa-lg"></i></a>
    </li>
  </ul>
</div>
<!--Add window-->
<div
  bsModal
  #myModal="bs-modal"
  class="modal fade"
  tabindex="-1"
  role="dialog"
  aria-labelledby="myModalLabel"
  aria-hidden="false"
>
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Ajouter un utilisateur</h4>
        <button
          type="button"
          class="close"
          (click)="myModal.hide(); resetAddModal()"
          aria-label="Close"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div
        class="progress"
        *ngIf="(loaderService.isLoading | async) && isAdding"
      >
        <div
          class="progress-bar progress-bar-striped progress-bar-animated bg-success"
          role="progressbar"
          aria-valuenow="75"
          aria-valuemin="0"
          aria-valuemax="100"
          style="width: 100%"
        ></div>
      </div>
      <div role="alert" class="alert alert-success" *ngIf="successAddUser">
        Un nouveau utilisateur est ajouté <strong>avec succès.</strong>
      </div>
      <div role="alert" class="alert alert-danger" *ngIf="errorAddUser">
        <strong>Oops! </strong> Modifiez quelques éléments et essayez de
        soumettre de nouveau !
      </div>
      <div class="modal-body">
        <div class="form-group custom-col">
          <label>Nom</label>
          <input
            type="text"
            placeholder="Nom"
            class="form-control"
            [(ngModel)]="newUser.lastName"
            style="color: black"
          />
          <span *ngIf="newUser.lastName == ''">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Prénom</label>
          <input
            type="text"
            placeholder="Prénom"
            class="form-control"
            [(ngModel)]="newUser.firstName"
            style="color: black"
          />
          <span *ngIf="newUser.firstName == ''">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Email</label>
          <input
            (blur)="uniquenessCheck()"
            type="text"
            (keyup)="checkSyntaxMail()"
            placeholder="Email"
            class="form-control"
            [(ngModel)]="newUser.email"
            style="color: black"
            [ngStyle]="inputStyle"
          />
          <span *ngIf="entityExist && newUser.email.length > 0">
            * Ce email existe déjà !
          </span>
          <span *ngIf="newUser.email === ''">
            * Ce champ est obligatoire !
          </span>
          <span *ngIf="syntaxMail && newUser.email != ''">
            * Ce email est invalid !
          </span>
        </div>
        <div class="form-group row" style="margin-bottom: 0rem">
          <label class="col-md-3 col-form-label">Role</label>
          <div class="col-md-9">
            <div class="form-check">
              <input
                type="radio"
                [(ngModel)]="newUser.roles[0]"
                id="radioRole1"
                name="radioRole"
                value="ROLE_USER"
                checked=""
                class="form-check-input"
              />
              <label for="radioRole1" class="form-check-label">
                Simple utilisateur
              </label>
            </div>
            <div class="form-check">
              <input
                type="radio"
                ngModel
                name="radioRole"
                id="radioRole2"
                [(ngModel)]="newUser.roles[0]"
                value="ROLE_ADMIN"
                class="form-check-input"
              />
              <label for="radioRole2" class="form-check-label"> Admin </label>
            </div>
          </div>
        </div>
        <div class="selectActif">
          <label>Actif</label>
          <label class="switch switch-label switch-pill switch-success">
            <input
              type="checkbox"
              [(ngModel)]="newUser.isActive"
              class="switch-input"
            />
            <span
              data-checked="✓"
              data-unchecked="✕"
              class="switch-slider"
            ></span>
          </label>
        </div>
      </div>
      <div class="modal-footer">
        <button
          type="button"
          class="btn btn-secondary"
          (click)="myModal.hide(); resetAddModal()"
        >
          Annuler
        </button>
        <button
          type="button"
          class="btn addButton"
          (click)="createNewUser(); uniquenessCheck()"
        >
          Ajouter
        </button>
      </div>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>
<!-- /.modal -->

<!--Modification window-->
<div
  bsModal
  #myUpdateModal="bs-modal"
  class="modal fade"
  tabindex="-1"
  role="dialog"
  aria-labelledby="myModalLabel"
  aria-hidden="false"
>
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Modifier ce type de site</h4>
        <button
          type="button"
          class="close"
          (click)="myUpdateModal.hide(); resetAddModal()"
          aria-label="Close"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div role="alert" class="alert alert-success" *ngIf="successAddUser">
        Ce type de site est modifié <strong> avec succès !</strong>
      </div>
      <div role="alert" class="alert alert-danger" *ngIf="errorAddUser">
        <strong>Oops !</strong> Modifiez quelques éléments et essayez de
        soumettre de nouveau !
      </div>
      <div class="modal-body">
        <div class="form-group custom-col">
          <label>Nom</label>
          <input
            type="text"
            placeholder="Nom"
            class="form-control"
            [(ngModel)]="updateUser.lastName"
            style="color: black"
          />
          <span *ngIf="newUser.lastName == ''">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Prénom</label>
          <input
            type="text"
            placeholder="Prénom"
            class="form-control"
            [(ngModel)]="updateUser.firstName"
            style="color: black"
          />
          <span *ngIf="newUser.firstName == ''">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Email</label>
          <input
            (blur)="uniquenessCheck()"
            type="text"
            placeholder="Email"
            class="form-control"
            [(ngModel)]="updateUser.email"
            style="color: black"
            [ngStyle]="inputStyle"
          />
          <span *ngIf="entityExist && newUser.email.length > 0">
            * Ce email existe déjà !
          </span>
          <span *ngIf="newUser.email === ''">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group row" style="margin-bottom: 0rem">
          <label class="col-md-3 col-form-label">Role</label>
          <div class="col-md-9">
            <div class="form-check">
              <input
                type="radio"
                [(ngModel)]="updateUser.roles[0]"
                id="radioRoleup1"
                name="radioRoleup"
                value="ROLE_USER"
                checked=""
                class="form-check-input"
              />
              <label for="radioRoleup1" class="form-check-label">
                Simple utilisateur
              </label>
            </div>
            <div class="form-check">
              <input
                type="radio"
                ngModel
                name="radioRoleup"
                id="radioRoleup2"
                [(ngModel)]="updateUser.roles[0]"
                value="ROLE_ADMIN"
                class="form-check-input"
              />
              <label for="radioRoleup2" class="form-check-label"> Admin </label>
            </div>
          </div>
        </div>
        <div class="selectActif">
          <label>Actif</label>
          <label class="switch switch-label switch-pill switch-success">
            <input
              type="checkbox"
              [(ngModel)]="newUser.isActive"
              class="switch-input"
            />
            <span
              data-checked="✓"
              data-unchecked="✕"
              class="switch-slider"
            ></span>
          </label>
        </div>
      </div>
      <div class="modal-footer">
        <button
          type="button"
          class="btn btn-secondary"
          (click)="myUpdateModal.hide()"
        >
          Annuler
        </button>
        <button
          type="button"
          class="btn addButton"
          (click)="putUser(); myUpdateModal.hide()"
        >
          Enregistrer
        </button>
      </div>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>
<!-- /.modal -->
